--------------------------------------------------------
-- PureQuery Repository Lite removal script for DB2 LUW
--- 
--  please make corresponding changes in tablespace and 
--  bufferpool names if you made any changes in Repository
--  setup script 
--------------------------------------------------------------
-- <ScriptOptions statementTerminator=";" />

drop view METADATASOURCE;
drop view CAPTUREDATA;
drop view METADATAGROUP;
drop view METADATAGROUPMEMBERS;
drop view CONTACT;
drop view SCHEMA_VERSION;

drop package AMDA1;
drop package AMDA2;
drop package AMDA3;
drop package AMDA4;

drop package AMDL1;
drop package AMDL2;
drop package AMDL3;
drop package AMDL4;

{upgrades};

ALTER TABLE METADATAGROUPMEMBERS_T DROP CONSTRAINT MDGM_MDS_T_FK;

ALTER TABLE METADATAGROUPMEMBERS_T DROP CONSTRAINT MDGM_MDG_T_FK;

ALTER TABLE METADATAGROUPMEMBERS_T DROP CONSTRAINT MDGM_MDG_2_T_FK;

ALTER TABLE METADATAGROUP_T DROP CONSTRAINT MDG_CONTACT_T_FK;

drop index METADATAGROUP_T_IDX;

drop table METADATASOURCE_T;
drop table CAPTUREDATA_T;
drop table METADATAGROUP_T;
drop table METADATAGROUPMEMBERS_T;
drop table CONTACT_T;
drop table SCHEMA_VERSION_T;

-- Epic #12485, Honor multiple schemas for repository
-- Since there could be multiple schemas and hence multiple repositories in the 
-- the same buffer pool and table space, we cannot drop these.
-- These 2 DROP statements will be commented by later part of the code in case of DB2 LUW.
-- When -generateScriptOnly option is used, these commented SQLs will be written to the .sql file.
-- User can then remove the comments from the .sql file and execute the SQLs if needed.
-- When the -generateScriptOnly option is not specified, these DROPs are not be executed.
drop tablespace PDQTS;

drop bufferpool PDQBP;

commit work;
